unit formMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  (*---TMap---------------------------------------------------------*)

  TMap = array[0..11,0..11] of TShape;

  (*---TGhost---------------------------------------------------------*)

  TGhost = class(TObject)
  private
  protected
     fMap         : TMap;
     fX           : integer;
     fY           : integer;
     fBitmask     : byte;
     fOldDir      : byte;
  public
    constructor create(map:TMap;bitmask:byte);

    procedure startPosition;
    procedure newXY(dir:byte;var nx,ny:integer);

    procedure move;
    procedure advMove;

    property x:integer read fX;
    property y:integer read fY;
  end;

  (*---Our Form---------------------------------------------------------*)

  TForm1 = class(TForm)
    cmdClear: TButton;
    cmdReset: TButton;
    cmdLaunch: TButton;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Shape5: TShape;
    Shape6: TShape;
    Shape7: TShape;
    Shape8: TShape;
    Shape9: TShape;
    Shape10: TShape;
    Shape11: TShape;
    Shape12: TShape;
    Shape13: TShape;
    Shape14: TShape;
    Shape15: TShape;
    Shape16: TShape;
    Shape17: TShape;
    Shape18: TShape;
    Shape19: TShape;
    Shape20: TShape;
    Shape21: TShape;
    Shape22: TShape;
    Shape23: TShape;
    Shape24: TShape;
    Shape25: TShape;
    Shape26: TShape;
    Shape27: TShape;
    Shape28: TShape;
    Shape29: TShape;
    Shape30: TShape;
    Shape31: TShape;
    Shape32: TShape;
    Shape33: TShape;
    Shape34: TShape;
    Shape35: TShape;
    Shape36: TShape;
    Shape37: TShape;
    Shape38: TShape;
    Shape39: TShape;
    Shape40: TShape;
    Shape41: TShape;
    Shape42: TShape;
    Shape43: TShape;
    Shape44: TShape;
    Shape45: TShape;
    Shape46: TShape;
    Shape47: TShape;
    Shape48: TShape;
    Shape49: TShape;
    Shape50: TShape;
    Shape51: TShape;
    Shape52: TShape;
    Shape53: TShape;
    Shape54: TShape;
    Shape55: TShape;
    Shape56: TShape;
    Shape57: TShape;
    Shape58: TShape;
    Shape59: TShape;
    Shape60: TShape;
    Shape61: TShape;
    Shape62: TShape;
    Shape63: TShape;
    Shape64: TShape;
    Shape65: TShape;
    Shape66: TShape;
    Shape67: TShape;
    Shape68: TShape;
    Shape69: TShape;
    Shape70: TShape;
    Shape71: TShape;
    Shape72: TShape;
    Shape73: TShape;
    Shape74: TShape;
    Shape75: TShape;
    Shape76: TShape;
    Shape77: TShape;
    Shape78: TShape;
    Shape79: TShape;
    Shape80: TShape;
    Shape81: TShape;
    Shape82: TShape;
    Shape83: TShape;
    Shape84: TShape;
    Shape85: TShape;
    Shape86: TShape;
    Shape87: TShape;
    Shape88: TShape;
    Shape89: TShape;
    Shape90: TShape;
    Shape91: TShape;
    Shape92: TShape;
    Shape93: TShape;
    Shape94: TShape;
    Shape95: TShape;
    Shape96: TShape;
    Shape97: TShape;
    Shape98: TShape;
    Shape99: TShape;
    Shape100: TShape;
    Shape101: TShape;
    Shape102: TShape;
    Shape103: TShape;
    Shape104: TShape;
    Shape105: TShape;
    Shape106: TShape;
    Shape107: TShape;
    Shape108: TShape;
    Shape109: TShape;
    Shape110: TShape;
    Shape111: TShape;
    Shape112: TShape;
    Shape113: TShape;
    Shape114: TShape;
    Shape115: TShape;
    Shape116: TShape;
    Shape117: TShape;
    Shape118: TShape;
    Shape119: TShape;
    Shape120: TShape;
    Shape121: TShape;
    Shape122: TShape;
    Shape123: TShape;
    Shape124: TShape;
    Shape125: TShape;
    Shape126: TShape;
    Shape127: TShape;
    Shape128: TShape;
    Shape129: TShape;
    Shape130: TShape;
    Shape131: TShape;
    Shape132: TShape;
    Shape133: TShape;
    Shape134: TShape;
    Shape135: TShape;
    Shape136: TShape;
    Shape137: TShape;
    Shape138: TShape;
    Shape139: TShape;
    Shape140: TShape;
    Shape141: TShape;
    Shape142: TShape;
    Shape143: TShape;
    Shape144: TShape;
    Shape145: TShape;
    Shape146: TShape;
    Shape147: TShape;
    Shape148: TShape;
    Shape149: TShape;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    tmrGhosts: TTimer;
    chkAdvMov: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure cmdLaunchClick(Sender: TObject);
    procedure cmdResetClick(Sender: TObject);
    procedure cmdClearClick(Sender: TObject);
    procedure tmrGhostsTimer(Sender: TObject);
  private
    { Private declarations }
    fMap                   : TMap;
    fRunning               : boolean;
    fRedGhost              : TGhost;
    fGreenGhost            : TGhost;
    fBlueGhost             : TGhost;
  public
    { Public declarations }
    procedure shapeClick(Sender:TObject;Button:TMouseButton;Shift:TShiftState;X,Y:Integer);
  end;

procedure setColor(aShape:TShape);

var
  Form1: TForm1;

implementation

{$R *.DFM}

// Constant bit values for TShape.tag of the map
// $01 = Spawn point
// $02 = Wall
// $04 = Red ghost
// $08 = Green ghost
// $10 = Blue ghost

procedure setColor(aShape:TShape);
var
   col : TColor;
begin
     if (aShape.tag=1) then
        aShape.brush.color:=clGray
     else
         if (aShape.tag=2) then
            aShape.brush.color:=clBlack
         else
             if (aShape.tag=0) then
                aShape.brush.color:=clSilver
             else
                 begin
                      col:=00;
                      if (aShape.tag and $4=$4) then
                         col:=col+$0000ff;
                      if (aShape.tag and $8=$8) then
                         col:=col+$00ff00;
                      if (aShape.tag and $10=$10) then
                         col:=col+$ff0000;

                      aShape.brush.color:=col;
                 end;
end;

procedure TForm1.shapeClick(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   ms : TShape;
begin
     if (not fRunning) then
        begin
             ms:=TShape(sender);

             if (ms.tag=0) then
                ms.tag:=1
             else
                 if (ms.tag=1) then
                    ms.tag:=2
                 else
                     if (ms.tag=2) then
                        ms.tag:=0;

             setColor(ms);
        end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
   x,y : integer;
   n   : integer;
begin
     // This is just a nasty horrible way of collecting the map cells
     for x:=0 to 11 do
         for y:=0 to 11 do
             begin
                  n:=y*12+x+1;

                  fMap[x,y]:=TShape(self.FindComponent('shape'+intToStr(n)));

                  if (fMap[x,y]=nil) then
                     showMessage('Could not find cell '+intToStr(x)+','+intToStr(y))
                  else
                      fMap[x,y].onMouseUp:=shapeClick;
             end;

     fRunning:=false;
end;

procedure TForm1.cmdLaunchClick(Sender: TObject);
var
   x,y : integer;
   sp  : boolean;
begin
     // Launch the ghosts
     cmdClear.enabled:=false;
     cmdLaunch.enabled:=false;

     // Do some checks... namely, do we have a start point
     sp:=false;
     for x:=0 to 11 do
         begin
             for y:=0 to 11 do
                 begin
                      if (fMap[x,y].tag and $1=1) then
                         begin
                              sp:=true;
                              break;
                         end;
                 end;

             if (sp) then
                break;
         end;

     if (not sp) then
        showMessage('You must provide a spawn point')
     else
         fRunning:=true;

     if (fRunning) then
        begin
             fRedGhost:=TGhost.create(fMap,$4);
             fGreenGhost:=TGhost.create(fMap,$8);
             fBlueGhost:=TGhost.create(fMap,$10);

             cmdReset.enabled:=true;
             tmrGhosts.enabled:=true;
        end
     else
         begin
              cmdLaunch.enabled:=true;
              cmdClear.enabled:=true;
         end;
end;

procedure TForm1.cmdResetClick(Sender: TObject);
var
   x,y : integer;
begin
     // Stop the ghosts
     cmdLaunch.enabled:=true;
     cmdClear.enabled:=true;
     cmdReset.enabled:=false;

     tmrGhosts.enabled:=false;

     fRunning:=false;

     for x:=0 to 11 do
         for y:=0 to 11 do
             begin
                  fMap[x,y].tag:=fMap[x,y].tag and $3;
                  setColor(fMap[x,y]);
             end;

     fRedGhost.free;
     fGreenGhost.free;
     fBlueGhost.free;
end;

procedure TForm1.cmdClearClick(Sender: TObject);
var
   x,y : integer;
begin
     for x:=0 to 11 do
         for y:=0 to 11 do
             begin
                  fMap[x,y].tag:=0;
                  setColor(fMap[x,y]);
             end;
end;

procedure TForm1.tmrGhostsTimer(Sender: TObject);
begin
     tmrGhosts.enabled:=false;

     if (chkAdvMov.checked) then
        begin
             fRedGhost.advMove;
             fGreenGhost.advMove;
             fBlueGhost.advMove;
        end
     else
         begin
             fRedGhost.move;
             fGreenGhost.move;
             fBlueGhost.move;
         end;

     application.processMessages;

     tmrGhosts.enabled:=fRunning;
end;

(*---Ghost---------------------------------------------------------*)

constructor TGhost.create(map:TMap;bitmask:byte);
begin
     inherited create;

     fMap:=map;
     fOldDir:=0;
     fBitmask:=bitMask;

     startPosition;
end;

procedure TGhost.startPosition;
var
   x,y : integer;
begin
     for x:=0 to 11 do
         for y:=0 to 11 do
             if (fMap[x,y].tag and $1=$1) then
                begin
                     fX:=x;
                     fY:=y;

                     fMap[fX,fY].tag:=fMap[fX,fY].tag or fBitmask;

                     setColor(fMap[fx,fy]);
                end;
end;

procedure TGhost.newXY(dir:byte;var nx,ny:integer);
begin
     nx:=fx;
     ny:=fy;

     case dir of
     1 : begin
              ny:=ny-1;
         end;
     2 : begin
              nx:=nx+1;
         end;
     3 : begin
              ny:=ny+1;
         end;
     4 : begin
              nx:=nx-1;
         end;
     end;
end;

procedure TGhost.move;
var
   nx,ny : integer;
begin
     // First remove ourselves from the map
     fMap[fX,fY].tag:=fMap[fX,fY].tag and byte(not fBitMask);
     setColor(fMap[fX,fY]);

     repeat
           // If we don't have an old direction then pick a random one
           if (fOldDir=0) then
              fOldDir:=random(4)+1
           else
               begin
                   // This should provide a 20% chance that the ghost will simply turn around
                   if (random(100)<20) then
                      begin
                           fOldDir:=fOldDir+2;
                           if (fOldDir>4) then
                              fOldDir:=fOldDir-4;
                      end;
               end;

           // Check that the ghost can actually move in the direction
           newXY(fOldDir,nx,ny);

           if (nx>=0) and (nx<=11) and (ny>=0) and (ny<=11) then
              begin
                   if (fMap[nx,ny].Tag and $3<>0) then
                      fOldDir:=0;
              end
           else
               fOldDir:=0;

     until (fOldDir<>0);

     newXY(fOldDir,nx,ny);

     fX:=nx;
     fY:=ny;

     fMap[fX,fY].tag:=fMap[fX,fY].tag or fBitMask;
     setColor(fMap[fX,fY]);

     // 1 - Up
     // 2 - Right
     // 3 - Down
     // 4 - Left
end;


procedure TGhost.advMove;
var
   canGo        : array[1..4] of boolean;
   loop         : integer;
   nx,ny        : integer;
   choices      : array[1..7] of byte;
   choiceCount  : byte;
begin
     // First remove ourselves from the map
     fMap[fX,fY].tag:=fMap[fX,fY].tag and byte(not fBitMask);
     setColor(fMap[fX,fY]);

     // Now from our current position, establish in which directions we can travel
     for loop:=1 to 4 do
         begin
              newXY(loop,nx,ny);

              if (nx>=0) and (nx<=11) and (ny>=0) and (ny<=11) and (fMap[nx,ny].tag and $3=0) then
                 canGo[loop]:=true
              else
                  canGo[loop]:=false;
         end;

     // Now, we want to weight our new direction of travel in the following way...
     // It is 4 times as likely to carry on in the same direction as any other action
     choiceCount:=0;
     if (canGo[fOldDir]) then
        begin
             choices[1]:=fOldDir;
             choices[2]:=fOldDir;
             choices[3]:=fOldDir;
             choices[4]:=fOldDir;
             choiceCount:=4;
        end;

     for loop:=1 to 4 do
         begin
              if (fOldDir<>loop) and (canGo[loop]) then
                 begin
                      inc(choiceCount);
                      choices[choiceCount]:=loop;
                 end;
         end;

     // Now we know where we can go and we've weighted our choices
     // pick a new one
     fOldDir:=choices[random(choiceCount)+1];

     // Put ourselves on the map
     newXY(fOldDir,nx,ny);

     fX:=nx;
     fY:=ny;

     fMap[fX,fY].tag:=fMap[fX,fY].tag or fBitMask;
     setColor(fMap[fX,fY]);
end;

end.
